<?php
/**
 * Plugin Name: Christmas Music
 * Text Domain: christmas-music
 *  Domain Path: /languages
 * Description: This plugin adds Christmas music to your site. Also has play/pause buttons at the bottom right corner of your site.
 * Version: 1.4.1
 * Author: Codelfo.com
 * Author URI: http://codelfo.com
 * License: GPL2
 */
 


 
/* 
MULTILANGUAGE 
*/



add_action('plugins_loaded', 'xmasmusic_translation');
function xmasmusic_translation() {
	load_plugin_textdomain( 'christmas-music', false, dirname( plugin_basename(__FILE__) ) . '/languages/' );
}



/* 
BACK-END FOR GLOBAL OPTIONS
*/

add_action('admin_menu', 'xmasmusic_plugin_menu');

function xmasmusic_plugin_menu() {
	add_options_page('Christmas Music settings', 'Christmas Music', 'administrator', 'xmas-music-settings', 'xmasmusic_plugin_settings_page', 'dashicons-admin-generic');
}


add_action( 'admin_init', 'xmasmusic_plugin_settings' );

function xmasmusic_plugin_settings() {
	register_setting( 'xmasmusic-plugin-settings-group', 'default_play' );
	register_setting( 'xmasmusic-plugin-settings-group', 'button_bg' );
	register_setting( 'xmasmusic-plugin-settings-group', 'button_color' );
}



add_action( 'admin_enqueue_scripts', 'xmasmusic_color_picker' );
function xmasmusic_color_picker() {
    // first check that $hook_suffix is appropriate for your admin page
    wp_enqueue_style( 'wp-color-picker' );
    wp_enqueue_script( 'xmasmusic-script-handle', plugins_url('/js/xmasmusic_color_pckr.js', __FILE__ ), array( 'wp-color-picker' ), false, true );
}



function xmasmusic_plugin_settings_page() {

  $background_button = esc_attr( get_option('button_bg'));
  
  if ($background_button) {
  }
  else {
    $background_button = '#ff0000';
  };
  
  
  $icon_button = esc_attr( get_option('button_color')); 
  
  if ($icon_button) {
  }
  else {
    $icon_button = '#ffffff';
  };
?>



<div class="wrap">
  <h1><?php printf( __( 'Christmas Music settings', 'christmas-music' )); ?></h1>
  <form method="post" action="options.php">
    <?php settings_fields( 'xmasmusic-plugin-settings-group' ); ?>
    <?php do_settings_sections( 'xmasmusic-plugin-settings-group' ); ?>

    <br><br>
    <h3 style="font-size: 24px; color: #333;"><?php printf( __( 'General Options', 'christmas-music' )); ?></h3>

    <hr>   

    <table class="form-table">   
      <tr valign="top">
        <td>
          <input type="checkbox" name="default_play" id="default_play" value="true"  <?php checked('true', get_option('default_play')); ?>> &nbsp; 
          <label for="default_play" style="font-size: 15px;"><b><?php printf( __( 'Play on all pages', 'christmas-music' )); ?></b></label> 
        </td>
      </tr>
      <tr>
        <td style="font-size: 14px; color: #777;"><?php printf( __( '* If the setting above is disabled, you can enable Christmas music for every post/custom post/custom post/page individually.', 'christmas-music' )); ?></td>
      </tr>
    </table>
 
    <hr>
    
    <br><br>
    <h3 style="font-size: 24px; color: #333;"><?php printf( __( 'Style Options', 'christmas-music' )); ?></h3>

    <hr>    
    <table>
      
      <tr valign="top">
        <td>
          <label for="button_color" style="font-size: 12px;"><b style="font-size: 15px !important;"><?php printf( __( 'BACKGROUND for the play/pause button', 'christmas-music' )); ?></b> <?php printf( __( ' (red by default):', 'christmas-music' )); ?></label> 
          <input type="text" name="button_bg" id="button_bg" value="<?php echo $background_button; ?>">

        </td>
      </tr>
     
      <tr valign="top">
        <td>
          <br>
          <label for="button_color" style="font-size: 12px;"><b style="font-size: 15px !important;"><?php printf( __( 'ICON COLOR for the play/pause button', 'christmas-music' )); ?></b> <?php printf( __( ' (white by default):', 'christmas-music' )); ?></label> 
          <input type="text" name="button_color" id="button_color" value="<?php echo $icon_button; ?>">

        </td>
      </tr>
      
    </table>
    <br>
    <hr> 



    <style type="text/css">
      .wp-picker-container {
        position: relative;
        top: 12px;
        left: 10px;
      }
          </style>

    <?php submit_button(); ?>
  </form>
</div>
<?php 
} 

function xmasmusic_plugin_settings_link($xmaxmusic_links) { 
  $xmasmusic_settings_link = '<a href="options-general.php?page=xmas-music-settings">'. sprintf(__('Settings', 'christmas-music')) .'</a>'; 
  array_unshift($xmaxmusic_links, $xmasmusic_settings_link); 
  return $xmaxmusic_links; 
} 
$xmasmusic_plugin = plugin_basename(__FILE__); 
add_filter("plugin_action_links_$xmasmusic_plugin", 'xmasmusic_plugin_settings_link' );



/* 
BACK-END FOR SINGULAR
*/

add_action( 'add_meta_boxes', 'xmasmusic_meta_box_add' );

function xmasmusic_meta_box_add() {
  $xmasmusic_types = get_post_types();
  foreach( $xmasmusic_types as $xmasmusic_type ) {
  	add_meta_box( 'xmasmusic-meta-box-id', sprintf(__('Christmas Music Settings', 'christmas-music')), 'xmasmusic_meta_box_cb', $xmasmusic_type, 'side', 'high' );
  }
}

function xmasmusic_meta_box_cb( $post ) {
	$xmasmusic_values = get_post_custom( $post->ID );
	$xmasmusic_check = isset( $xmasmusic_values['xmasmusic_meta_box_check'] ) ? esc_attr( $xmasmusic_values['xmasmusic_meta_box_check'][0] ) : '';
	wp_nonce_field( 'xmasmusic_meta_box_nonce', 'meta_box_nonce' );
?>
	
	<p>
		<input type="checkbox" name="xmasmusic_meta_box_check" id="xmasmusic_meta_box_check" <?php checked( $xmasmusic_check, 'on' ); ?> />
		<label for="xmasmusic_meta_box_check"><?php printf( __( 'Play Christmas music on this page', 'christmas-music' )); ?></label><br><br>
		<span style="display: block; font-style: italic; font-size: 12px;"><?php printf( __( '* affecting only if globally ', 'christmas-music' )); ?><a href="options-general.php?page=xmas-music-settings" target="_blank"><?php printf( __( 'disabled here', 'christmas-music' )); ?></a></span>
	</p>
	<?php	
}


add_action( 'save_post', 'xmasmusic_meta_box_save' );

function xmasmusic_meta_box_save( $post_id ) {
	if( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) return;
  if( !isset( $_POST['meta_box_nonce'] ) || !wp_verify_nonce( $_POST['meta_box_nonce'], 'xmasmusic_meta_box_nonce' ) ) return;
	if ( ! current_user_can( 'edit_post', $post_id) )
  return;	
  if ( isset( $_POST['xmasmusic_meta_box_check'] ) && $_POST['xmasmusic_meta_box_check'] ) {
    add_post_meta( $post_id, 'xmasmusic_meta_box_check', 'on', true );
  } 
  else {
    delete_post_meta( $post_id, 'xmasmusic_meta_box_check' );
  }
}



/*
SCRIPTS ADDING 
*/

function xmasmusic_enqueued_assets() {    
  wp_enqueue_style( 'xmas-style', 'https://maxcdn.bootstrapcdn.com/font-awesome/4.5.0/css/font-awesome.min.css' );    
  wp_enqueue_style( 'xmas-style2', plugin_dir_url( __FILE__ ) . 'css/christmas-music.css' );    
  wp_enqueue_script( 'xmas-script', plugin_dir_url( __FILE__ ) . '/js/christmas-music.js', array( 'jquery' ), '1.0', true );    
  $xmasmusic_loc = array( 'templateUrl' => plugin_dir_url( __FILE__ ) );      
  wp_localize_script( 'xmas-script', 'object_name', $xmasmusic_loc );
} 




function xmasmusic_custom_stylesheet() {

  $background_button = esc_attr( get_option('button_bg'));
  
  if ($background_button) {
  }
  else {
    $background_button = '#ff0000';
  };
  
  
  $icon_button = esc_attr( get_option('button_color')); 
  
  if ($icon_button) {
  }
  else {
    $icon_button = '#ffffff';
  };

  echo '
       <style type="text/css">
            #sound_switcher { 
              background: '.$background_button.'; 
            }    
            #sound_switcher .fa { 
              color: '.$icon_button.' !important; 
            }    
       </style>
    ';
}
add_action( 'wp_print_styles', 'xmasmusic_custom_stylesheet' );




/*
GLOBAL OPTIONS CONDITION 
*/

add_action('wp', 'xmasmusic_glob_setting');

function xmasmusic_glob_setting() {
  if (get_option('default_play')==true) {
    add_action( 'wp_enqueue_scripts', 'xmasmusic_enqueued_assets' );
  }
}



/*
SINGULAR OPTIONS CONDITION 
*/

add_action('wp', 'xmasmusic_post_setting');

function xmasmusic_post_setting() {
  global $post;
  $xmasmusic_post_meta = get_post_meta( $post->ID, 'xmasmusic_meta_box_check', true);
  if( $xmasmusic_post_meta == 'on' && is_singular()  ) {  
     add_action( 'wp_enqueue_scripts', 'xmasmusic_enqueued_assets' ); 
  }    
  else {}
}


?>